#include "utils.PRO2"
#include "Estudiant.hpp"
#include "Pila1.hpp"


bool cerca_pila_int(Pila<int> & p, int x)
/* Pre: cert */
{
  while(not p.empty()){
    if (p.top() == x) return true;
    else p.pop();
  }
  return false;
}
/* Post: El resultat ens diu si x és un element de p o no */


void llegir_pila_Estudiant(Pila<Estudiant> &p, int marca)
{
  Estudiant n;
  n.llegir_estudiant();
  while (n.consultar_DNI() != marca){
    p.push(n);
    n.llegir_estudiant();
  }
}

void escriure_pila_Estudiant(const Pila<Estudiant> &p)
{
  cout << "[Cim] " << endl;
  Pila<Estudiant> copia(p);     
  while(not copia.empty()){ 
    copia.top().escriure_estudiant();
    copia.pop(); 
  }                   
  cout << "[Ultim]"<<endl;
}

bool cerca_pila_Estudiant(Pila<Estudiant> &p, int x)
/* Pre: x > 0 */
{
  bool ret=false;
  while(not p.empty() and not ret){
    if (p.top().consultar_DNI() == x) ret=true;
    else p.pop();
  }
  return ret;
}
/* Post: El resultat ens diu si hi ha algun estudiant amb dni x a p */


int main(){

  Pila<int> p;
  cout << "Entra pila d'enters (acabada per 0): " << endl;
  p.llegir_pila(0);
  cout << "La pila és: " << endl;
  p.escriure_pila();
  Pila<int> q = p;
  int x;
  cout << "Número a cercar: "; 
  cin >> x;
  if (cerca_pila_int(q,x)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  p.escriure_pila();
  Pila<Estudiant> pest;
  cout << "Entra pila d'Estudiants (acabada per dni 0): " << endl;
  //llegir_pila_Estudiant(pest,0);
  Estudiant est;
  pest.llegir_pila(est);
  cout << "Entra dni a cercar: " << endl;
  cin >> x;
  if (cerca_pila_Estudiant(pest,x)) cout << "Hi és" << endl;
  else cout << "No hi és" << endl;
  escriure_pila_Estudiant(pest);
  //pest.escriure_pila();
}


