#ifndef ESTUDIANT_HPP
#define ESTUDIANT_HPP

#include "utils.PRO2"

class Estudiant {

private:    
  int DNI;
  double nota;
  bool teNota;
  static const int MAX_NOTA = 10;

public:


  /* Constructores */
  Estudiant();
  Estudiant(int dni);

  /* Destructora por defecte */
  ~Estudiant();

  /* Modificadores */
  void afegir_nota(double nota);
  void modificar_nota(double nota);

 /* Consultores */
  bool te_nota() const;
  double consultar_nota() const;
  int consultar_DNI() const;

  /* Entrada / Sortida */
  void llegir_estudiant();
  void escriure_estudiant() const;
};
#endif
