#include "Estudiant.hpp"
#include "Cjt_Estudiants.hpp"
#include "E_Cjt_Estudiants.hpp"



void arrodonir(Estudiant & est)
/* Pre: est tiene nota */
{
  est.modificar_nota(((int) (10. * (est.consultar_nota() + 0.05))) / 10.0);
}
/* Post: est pasa a tener su nota original redondeada */


void arrodonir_notes(Cjt_estudiants &cest){
  Estudiant est;
  for (int i=1; i<= cest.mida(); i++){
    est=cest.consultar_iessim(i);
    arrodonir(est);
    cest.modificar_iessim(i,est);
  }
}

int main(){

  Cjt_estudiants cest;

  cest.llegir_cjt_estudiants();

  int n;
  cin >> n;

  int dni;
  double nota;
  Estudiant est;

  while (n!=-6){
    switch (n){
    case -1:
      est.llegir_estudiant(); 
      if (cest.existeix_estudiant(est.consultar_DNI()))
	cout << "L'estudiant " << est.consultar_DNI() << " ja existeix" << endl;
      else 
	cest.afegir_estudiant(est);
      break;
    case -2:
      cin >> dni;
      if (cest.existeix_estudiant(dni)){
	est=cest.consultar_estudiant(dni);
	if (est.te_nota()) cout << est.consultar_nota() << endl;
	else cout << "NP" << endl;
      } else cout << "L'estudiant " << dni << " no hi és" << endl;
      break;
    case -3:
      cin >> dni;
      cin >> nota;
      if (cest.existeix_estudiant(dni)){
	est=cest.consultar_estudiant(dni);
	if (est.te_nota())
	  est.modificar_nota(nota);
	else est.afegir_nota(nota);
	cest.modificar_estudiant(est);
      } else cout << "L'estudiant " << dni << " no hi és" << endl;
      break;
    case -4:
      arrodonir_notes(cest);
      break;
    case -5:
      cest.escriure_cjt_estudiants();
      cout << endl;
      break;
    }
    cin >> n;
  }
  cout << "Estudiant amb nota màxima: " << 
    estudiant_nota_max(cest).consultar_DNI() << endl;
}


